package com.example.zego_zpns.internal;

import android.util.Log;

import java.lang.reflect.Field;
import java.util.HashMap;
import java.util.Objects;

import im.zego.zpns.entity.ZPNsMessage;
import im.zego.zpns.entity.ZPNsRegisterMessage;
import im.zego.zpns.util.ZPNsConfig;


public class ZPNsConverter {
    static public ZPNsConfig cnvZPNsConfigMapToObject(HashMap<String,Object> configMap){
        ZPNsConfig zpnsConfig = new ZPNsConfig();

        zpnsConfig.hw_push = (Boolean) (Objects.requireNonNull(configMap.get("hw_push")));
        zpnsConfig.xiaomi_push = (Boolean) (Objects.requireNonNull(configMap.get("xiaomi_push")));
        zpnsConfig.vivo_push = (Boolean) (Objects.requireNonNull(configMap.get("vivo_push")));
        zpnsConfig.oppo_push = (Boolean) (Objects.requireNonNull(configMap.get("oppo_push")));
        zpnsConfig.fcm_push = (Boolean) (Objects.requireNonNull(configMap.get("fcm_push")));
        zpnsConfig.miAppID = (String) (Objects.requireNonNull(configMap.get("miAppID")));
        zpnsConfig.miAppKEY = (String) (Objects.requireNonNull(configMap.get("miAppKEY")));
        zpnsConfig.oppoAppID = (String) (Objects.requireNonNull(configMap.get("oppoAppID")));
        zpnsConfig.oppoAppSecret = (String) (Objects.requireNonNull(configMap.get("oppoAppSecret")));
        zpnsConfig.oppoAppKey = (String) (Objects.requireNonNull(configMap.get("oppoAppKey")));
        zpnsConfig.vivoAppID = (String) (Objects.requireNonNull(configMap.get("vivoAppID")));
        zpnsConfig.vivoAppKey = (String) (Objects.requireNonNull(configMap.get("vivoAppKey")));
        zpnsConfig.hwAppID = (String) (Objects.requireNonNull(configMap.get("hwAppID")));

        return zpnsConfig;
    }

    static public HashMap<String,Object> cnvZPNsConfigObjectToMap(ZPNsConfig zpnsConfig){
        HashMap<String,Object> zpnsConfigMap = new HashMap<>();
        zpnsConfigMap.put("hw_push",zpnsConfig.hw_push);
        zpnsConfigMap.put("xiaomi_push",zpnsConfig.xiaomi_push);
        zpnsConfigMap.put("vivo_push",zpnsConfig.vivo_push);
        zpnsConfigMap.put("oppo_push",zpnsConfig.oppo_push);
        zpnsConfigMap.put("fcm_push",zpnsConfig.fcm_push);
        zpnsConfigMap.put("miAppID",zpnsConfig.miAppID);
        zpnsConfigMap.put("miAppKEY",zpnsConfig.miAppKEY);
        zpnsConfigMap.put("oppoAppID",zpnsConfig.oppoAppID);
        zpnsConfigMap.put("oppoAppSecret",zpnsConfig.oppoAppSecret);
        zpnsConfigMap.put("oppoAppKey",zpnsConfig.oppoAppKey);
        zpnsConfigMap.put("vivoAppID",zpnsConfig.vivoAppID);
        zpnsConfigMap.put("vivoAppKey",zpnsConfig.vivoAppKey);
        zpnsConfigMap.put("hwAppID",zpnsConfig.hwAppID);
        return zpnsConfigMap;
    }

    static public HashMap<String,Object> cnvZPNsMessageObjectToMap(ZPNsMessage message) {

        HashMap<String,Object> messageMap = new HashMap<>();
        messageMap.put("title",message.getTitle());
        messageMap.put("content",message.getContent());
        messageMap.put("pushType",message.getPushType().code());
        messageMap.put("pushSource",message.getPushSource().code());

        //利用反射将 extra object 转为 map
        try{
            HashMap<String, Object> extraMap = new HashMap<String, Object>();
            Field[] fields = message.getExtra().getClass().getDeclaredFields();
            for (Field field : fields) {
                field.setAccessible(true);
                extraMap.put(field.getName(), field.get(message.getExtra()));
            }
            messageMap.put("extraMap",extraMap);
        }catch (IllegalAccessException e){
            Log.e("ZPNsConverter","converter zpns message extra IllegalAccessException");
        }


        messageMap.put("notifyId",message.getNotifyId());

        return messageMap;
    }

    static public HashMap<String,Object> cnvZPNsRegisterMessageObjectToMap(ZPNsRegisterMessage registerMessage){
        HashMap<String,Object> messageMap = new HashMap<>();
        messageMap.put("errorCode",registerMessage.getErrorCode().getCode());
        messageMap.put("msg",registerMessage.getMsg());
        messageMap.put("pushID",registerMessage.getCommandResult());
        messageMap.put("commandResult",registerMessage.getCommandResult());
        messageMap.put("pushSource",registerMessage.getPushSource());
        messageMap.put("pushCmdType",registerMessage.getPushCmdType());

//        //利用反射将 extra object 转为 map
//        try{
//            HashMap<String, Object> extraMap = new HashMap<String, Object>();
//            Field[] fields = registerMessage.ge.getClass().getDeclaredFields();
//            for (Field field : fields) {
//                field.setAccessible(true);
//                extraMap.put(field.getName(), field.get(registerMessage.getExtra()));
//            }
//            messageMap.put("extraMap",extraMap);
//        }catch (IllegalAccessException e){
//            Log.e("ZPNsConverter","converter zpns message extra IllegalAccessException");
//        }
        return  messageMap;
    }
}
