package com.example.zego_zpns.internal;

import android.content.Context;

import java.util.HashMap;

import im.zego.zpns.ZPNsMessageReceiver;

import im.zego.zpns.entity.ZPNsMessage;
import im.zego.zpns.entity.ZPNsRegisterMessage;

import io.flutter.plugin.common.EventChannel;

public class ZPNsPluginEventHandler extends ZPNsMessageReceiver{
    
    public static EventChannel.EventSink mysink = null;

    public void setSink(EventChannel.EventSink sink){
        mysink = sink;
    }

    @Override
    protected void onThroughMessage(Context context, ZPNsMessage message) {
        if(mysink == null){
            return;
        }
        HashMap<String,Object> resultMap = new HashMap<>();
        resultMap.put("method","onThroughMessage");
        resultMap.put("message",ZPNsConverter.cnvZPNsMessageObjectToMap(message));
        mysink.success(resultMap);
    }

    @Override
    protected void onNotificationClicked(Context context, ZPNsMessage message) {
        if(mysink == null){
            return;
        }
        HashMap<String,Object> resultMap = new HashMap<>();

        HashMap<String,String> messageMap = new HashMap<>();
        messageMap.put("title",message.getTitle());
        messageMap.put("content",message.getContent());
        messageMap.put("extendedData","");

        resultMap.put("method","onNotificationClicked");
        resultMap.put("message",messageMap);

        //TODO:将各厂商的透传字段中把 extend data 解析出来。
       // resultMap.put("message",ZPNsConverter.cnvZPNsMessageObjectToMap(message));

        mysink.success(resultMap);

    }

    @Override
    protected void onNotificationArrived(Context context, ZPNsMessage message) {
        if(mysink == null){
            return;
        }
        HashMap<String,Object> resultMap = new HashMap<>();

        HashMap<String,String> messageMap = new HashMap<>();
        messageMap.put("title",message.getTitle());
        messageMap.put("content",message.getContent());
        messageMap.put("extendedData","");

        resultMap.put("method","onNotificationArrived");
        resultMap.put("message",messageMap);

        //TODO:将各厂商的透传字段中把 extend data 解析出来。
        //resultMap.put("message",ZPNsConverter.cnvZPNsMessageObjectToMap(message));
        mysink.success(resultMap);
    }

    @Override
    protected void onRegistered(Context context, ZPNsRegisterMessage message) {
        if(mysink == null){
            return;
        }
        HashMap<String,Object> resultMap = new HashMap<>();

        resultMap.put("method","onRegistered");

        HashMap<String,Object> messageMap = new HashMap<>();
        messageMap.put("pushID",message.getCommandResult());
        messageMap.put("errorCode",message.getErrorCode().getCode());

        resultMap.put("message",messageMap);
        mysink.success(resultMap);
    }
}
