package com.example.zego_zpns.internal;

import android.app.Application;
import android.service.controls.actions.BooleanAction;

import java.lang.invoke.MethodHandle;
import java.util.HashMap;
import java.util.Objects;

import im.zego.zpns.ZPNsManager;
import im.zego.zpns.util.ZPNsConfig;
import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel.Result;
public class ZPNsPluginMethodHandler {

    public static void getVersion(MethodCall call, Result result){
        result.success(ZPNsManager.getInstance().getVersion());

    }

    public static void registerPush(MethodCall call, Result result, FlutterPlugin.FlutterPluginBinding binding){
        Application application = (Application) binding.getApplicationContext();
        ZPNsManager.getInstance().registerPush(application);
        result.success(null);
    }

    public static void getPushConfig(MethodCall call, Result result){

        HashMap<String,Object> resultMap = new HashMap<>();

        HashMap<String,Object> configMap = ZPNsConverter.cnvZPNsConfigObjectToMap(ZPNsManager.getInstance().getPushConfig());

        resultMap.put("config",configMap);

        result.success(resultMap);
    }

    public static void setPushConfig(MethodCall call,Result result){
        ZPNsConfig zpnsConfig = ZPNsConverter.cnvZPNsConfigMapToObject(Objects.requireNonNull(call.argument("config")));
        ZPNsManager.setPushConfig(zpnsConfig);
        result.success(null);
    }

    public static void enableDebug(MethodCall call,Result result){
       Boolean enableDebug = call.argument("debug");
       if(enableDebug != null){
           ZPNsManager.enableDebug(enableDebug);
           result.success(null);
       } else{
           result.error("1","enableDebug is equal null",null);
       }
    }

    public static void applyNotificationPermission(MethodCall call,Result result){
        result.success(null);
    }



    public static void unregisterPush(MethodCall call,Result result){
        ZPNsManager.getInstance().unregisterPush();
        result.success(null);
    }

}
