import 'package:zego_zpns/src/zpns_defines.dart';

class ZPNsConverter {
  static ZPNsConfig cnvZPNsConfigMapToObject(Map configMap) {
    ZPNsConfig zpnsConfig = ZPNsConfig();

    zpnsConfig.hwPush = configMap['hw_push'];
    zpnsConfig.xiaomiPush = configMap['xiaomi_push'];
    zpnsConfig.vivoPush = configMap['vivo_push'];
    zpnsConfig.oppoPush = configMap['oppo_push'];
    zpnsConfig.fcmPush = configMap['fcm_push'];

    zpnsConfig.miAppID = configMap['miAppID'];
    zpnsConfig.miAppKEY = configMap['miAppKEY'];

    zpnsConfig.oppoAppID = configMap['oppoAppID'];
    zpnsConfig.oppoAppSecret = configMap['oppoAppSecret'];
    zpnsConfig.oppoAppKey = configMap['oppoAppKey'];

    zpnsConfig.vivoAppID = configMap['vivoAppID'];
    zpnsConfig.vivoAppKey = configMap['vivoAppKey'];

    zpnsConfig.hwAppID = configMap['hwAppID'];

    return zpnsConfig;
  }

  static Map cnvZPNsConfigObjectToMap(ZPNsConfig config) {
    Map configMap = {};

    configMap['hw_push'] = config.hwPush;
    configMap['xiaomi_push'] = config.xiaomiPush;
    configMap['vivo_push'] = config.vivoPush;
    configMap['oppo_push'] = config.oppoPush;
    configMap['fcm_push'] = config.fcmPush;

    configMap['miAppID'] = config.miAppID;
    configMap['miAppKEY'] = config.miAppKEY;
    configMap['oppoAppID'] = config.oppoAppID;
    configMap['oppoAppSecret'] = config.oppoAppSecret;
    configMap['oppoAppKey'] = config.oppoAppKey;

    configMap['vivoAppID'] = config.vivoAppID;
    configMap['vivoAppKey'] = config.vivoAppKey;

    configMap['hwAppID'] = config.hwAppID;

    return configMap;
  }

  static ZPNsMessage cnvZPNsMessageMapToObject(Map messageMap) {
    ZPNsMessage zpnsMessage = ZPNsMessage();
    zpnsMessage.title = messageMap['title'];
    zpnsMessage.content = messageMap['content'];
    zpnsMessage.extendData = messageMap['extendData'];
    return zpnsMessage;
  }

  static ZPNsRegisterMessage cnvZPNsRegisterMessageMapToObject(Map messageMap) {
    ZPNsRegisterMessage registerMessage = ZPNsRegisterMessage(
        errorCode: messageMap["errorCode"], pushID: messageMap["pushID"]);
    return registerMessage;
  }
}
