import 'dart:async';
import 'package:flutter/services.dart';
import 'package:zego_zpns/src/internal/zpns_converter.dart';
import 'package:zego_zpns/zego_zpns.dart';

class ZPNsEventHandlerImpl implements ZPNsEventHandler {
  static const EventChannel _eventChannel = EventChannel('zpns_event_handler');
  static StreamSubscription<dynamic>? _streamSubscription;

  static void registerEventHandler() async {
    _streamSubscription =
        _eventChannel.receiveBroadcastStream().listen(eventListener);
  }

  static void unregisterEventHandler() async {
    await _streamSubscription?.cancel();
    _streamSubscription = null;
  }

  static void eventListener(dynamic data) {
    final Map<dynamic, dynamic> map = data;
    switch (map['method']) {
      case 'onRegistered':
        if (ZPNsEventHandler.onRegistered == null) return;
        ZPNsRegisterMessage registerMessage =
            ZPNsConverter.cnvZPNsRegisterMessageMapToObject(map['message']);
        ZPNsEventHandler.onRegistered!(registerMessage);
        break;
      case 'onNotificationArrived':
        if (ZPNsEventHandler.onNotificationArrived == null) return;
        ZPNsMessage message =
            ZPNsConverter.cnvZPNsMessageMapToObject(map['message']);
        ZPNsEventHandler.onNotificationArrived!(message);
        break;
      case 'onNotificationClicked':
        if (ZPNsEventHandler.onNotificationClicked == null) return;

        ZPNsMessage message =
            ZPNsConverter.cnvZPNsMessageMapToObject(map['message']);

        ZPNsEventHandler.onNotificationClicked!(message);
        break;
      default:
    }
  }
}
