
///Description: ZPNs push configuration class.
///
///Use cases: Add the required configuration items pushed by each vendor and a Boolean value for whether to enable them.
class ZPNsConfig {
  bool hwPush = false;
  bool xiaomiPush = false;
  bool vivoPush = false;
  bool oppoPush = false;
  bool fcmPush = false;
  String miAppID = "";
  String miAppKEY = "";
  String oppoAppID = "";
  String oppoAppSecret = "";
  String oppoAppKey = "";
  String vivoAppID = "";
  String vivoAppKey = "";
  String hwAppID = "";
}

///Description: ZPNs message class.
///
///Use cases: Use the object of this data class to get the details of the push message.
class ZPNsMessage {
  String title = "";
  String content = "";
  String extendData = "";
}

class ZPNsRegisterMessage {
  String pushID;
  int errorCode;
  ZPNsRegisterMessage({required this.errorCode, required this.pushID});
}

