
import 'package:zego_zpns/zego_zpns.dart';

class ZPNsEventHandler {

///Available since: 2.0.0 or later.
///
///Description: This callback can be implemented to return the PushID generated by ZPNs after the [register] call.
///    
///Use cases: Developers can implement this callback if they need to get PushID after they connect to the SDK.
///
///When to call /Trigger: This notification is triggered after a call to [setDeviceToken].
  static void Function(ZPNsRegisterMessage registerMessage)? onRegistered;


///Available since: 2.0.0 or later.
///
///Description: Vendor notification display callback.
///
///When to call /Trigger: Vendor notification displays are uniformly thrown on this interface when a callback is triggered.
  static void Function(ZPNsMessage message)? onNotificationArrived;

///Available since: 2.0.0 or later.
///
///Description: Vendor notification click callback.
///    
///When to call /Trigger: Each vendor's notification click callback is uniformly thrown in this interface.
  static void Function(ZPNsMessage message)? onNotificationClicked;
}
